#ifndef DUCHAMP_SEARCHER_H_
#define DUCHAMP_SEARCHER_H_

#include <iostream>
#include <duchamp/duchamp.hh>
#include <duchamp/DataArrays/AstroImage.hh>
#include <duchamp/Detection/detection.hh>

namespace duchamp
{

    template <class T>
    class Searcher
    {
    public:
	Searcher();
	Searcher(const DuchampFinder& finder);
	Searcher(const Searcher& other);
	Searcher& operator= (const Searcher& other);
	virtual ~Searcher(){};

	void search(); // use search3DArray in Cubes/CubicSearch.cc
	void spatialSearch();// use search3DArraySpatial in Cubes/CubicSearch.cc
	void spectralSearch();// use search3DArraySpectral in Cubes/CubicSearch.cc

    protected:
	AstroImage<T> *itsImage;
	std::vector<Detection> *itsDetectionList; // Use Catalogue?
	Param *itsParam;
	
    };

}

#endif
